package il.ac.tau.cs.sw1.sortedset;

// TODO add import for SymetricDifferenceSortedSet

import java.util.Iterator;
import java.util.TreeSet;


/**
 * A simple implementation of a sorted set.
 * This class is provided as an example and for testing purposes.
 */
public class SimpleSortedSet implements SortedSet<Integer> {
	
	private java.util.SortedSet<Integer> values;
	
	/**
	 * Constructs a new SimpleSortedSet with the given int array as elements of the set
	 * the elements of the set are all of type Integer, and are determined at construction
	 * of the set.
	 */
	public SimpleSortedSet (int[] values) {
		this.values = new TreeSet<Integer>();
		if (values != null) {
			for (int i = 0; i < values.length; ++i) {
				this.values.add(values[i]);
			}
		}
	}
	
	@Override
	public int size() {
		return values.size();
	}
	
	@Override
	public boolean contains (Integer element) {
		return values.contains(element);
	}
	
	@Override
	public boolean isEmpty () {
		return values.isEmpty();
	}
	
	@Override
	public Integer getMinimum() {
		return values.first();
	}
	
	@Override
	public Integer getMaximum() {
		return values.last();
	}
	
	@Override
	public SortedIterator<Integer> iterator() {
		return new SimpleSortedIterator();
	}
	
	/**
	 * A default implementation for SortedIterator
	 * wrapss an iterator that is known to be sorted
	 */
	class SimpleSortedIterator implements SortedIterator<Integer> {

		SimpleSortedIterator() {
			iter = values.iterator();
		}
		
		@Override
		public boolean hasNext() {
			return iter.hasNext();
		}

		@Override
		public Integer next() {
			return iter.next();
		}

		@Override
		public void remove() {
			iter.remove();
		}
		
		Iterator<Integer> iter;
	}
	
	
	public static void main (String[] args) {
		SimpleSortedSet setA = new SimpleSortedSet(new int[] {1,2,3,4});
		SimpleSortedSet setB = new SimpleSortedSet(new int[] {1,2,3,4});
		SortedSet<Integer> setC = new SymetricDifferenceSortedSet<Integer>(setA, setB);
		Iterator<Integer> iter = setC.iterator();
		while (iter.hasNext()) {
			System.out.println(iter.next());
		}
		System.out.println("size = " + setC.size());
		System.out.println("maximum = " + setC.getMaximum());
		System.out.println("minimum = " + setC.getMinimum());
		System.out.println("empty ? = " + setC.isEmpty());
	}
	
}


